#ifndef _PG_LIBPQTYPES_H
#define _PG_LIBPQTYPES_H

// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the PG_LIBPQTYPES_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// PG_LIBPQTYPES_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef PG_LIBPQTYPES_EXPORTS
#define PG_LIBPQTYPES_API __declspec(dllexport)
#else
 #ifndef PG_LIBPQTYPES_STATIC
 #define PG_LIBPQTYPES_API __declspec(dllimport)
 #else  
 #define PG_LIBPQTYPES_API
 #endif
#endif

extern PG_LIBPQTYPES_API const char PG_BOOL[];
extern PG_LIBPQTYPES_API const char PG_INT2[];
extern PG_LIBPQTYPES_API const char PG_INT4[];
extern PG_LIBPQTYPES_API const char PG_INT8[];
extern PG_LIBPQTYPES_API const char PG_FLOAT4[];
extern PG_LIBPQTYPES_API const char PG_FLOAT8[];
extern PG_LIBPQTYPES_API const char PG_VARCHAR[];
extern PG_LIBPQTYPES_API const char PG_DATE[];
extern PG_LIBPQTYPES_API const char PG_TIMESTAMP[];
extern PG_LIBPQTYPES_API const char PG_INTERVAL[];
extern PG_LIBPQTYPES_API const char PG_MAC_ADDR[];
extern PG_LIBPQTYPES_API const char PG_INET[];
extern PG_LIBPQTYPES_API const char PG_NULL[];

extern PG_LIBPQTYPES_API const char PG_BOOL_ARR[];
extern PG_LIBPQTYPES_API const char PG_INT2_ARR[];
extern PG_LIBPQTYPES_API const char PG_INT4_ARR[];
extern PG_LIBPQTYPES_API const char PG_INT8_ARR[];
extern PG_LIBPQTYPES_API const char PG_FLOAT4_ARR[];
extern PG_LIBPQTYPES_API const char PG_FLOAT8_ARR[];
extern PG_LIBPQTYPES_API const char PG_VARCHAR_ARR[];
extern PG_LIBPQTYPES_API const char PG_DATE_ARR[];
extern PG_LIBPQTYPES_API const char PG_TIMESTAMP_ARR[];
extern PG_LIBPQTYPES_API const char PG_INTERVAL_ARR[];
extern PG_LIBPQTYPES_API const char PG_MAC_ADDR_ARR[];
extern PG_LIBPQTYPES_API const char PG_INET_ARR[];

extern PG_LIBPQTYPES_API const char PG_BOOL_VEC[];
extern PG_LIBPQTYPES_API const char PG_INT2_VEC[];
extern PG_LIBPQTYPES_API const char PG_INT4_VEC[];
extern PG_LIBPQTYPES_API const char PG_INT8_VEC[];
extern PG_LIBPQTYPES_API const char PG_FLOAT4_VEC[];
extern PG_LIBPQTYPES_API const char PG_FLOAT8_VEC[];
extern PG_LIBPQTYPES_API const char PG_VARCHAR_VEC[];
extern PG_LIBPQTYPES_API const char PG_DATE_VEC[];
extern PG_LIBPQTYPES_API const char PG_TIMESTAMP_VEC[];
extern PG_LIBPQTYPES_API const char PG_MAC_ADDR_VEC[];
extern PG_LIBPQTYPES_API const char PG_INET_VEC[];

//POD types
extern PG_LIBPQTYPES_API const char _INT8[];
extern PG_LIBPQTYPES_API const char _INT4[];
extern PG_LIBPQTYPES_API const char _INT2[];
extern PG_LIBPQTYPES_API const char _FLOAT4[];
extern PG_LIBPQTYPES_API const char _FLOAT8[];
extern PG_LIBPQTYPES_API const char _STDSTRING[];
extern PG_LIBPQTYPES_API const char _CONSTCHARSTR[];

//template <class T> class PG_LIBPQTYPES_API CDBExecutor;
// This class is exported from the PG_LibPQTypes.dll
//class PG_LIBPQTYPES_API CPG_LibPQTypes {
//public:
//	CPG_LibPQTypes(void);
	// TODO: add your methods here.
//};
//extern PG_LIBPQTYPES_API int nPG_LibPQTypes;

//PG_LIBPQTYPES_API int fnPG_LibPQTypes(void);
//extern PQT_EXPORT int
//PQgetf(const PGresult *res, int tup_num, const char *fieldspec, ...);
class NullDummyInet {};
class NullDummyMacaddr{};

#endif
